<?php

/**
 * Business rules for Pages
 */
class TeamMember extends EvTeamAppModel {

	public $displayField = 'name';

	public $actsAs = array(
		'MetaData.Meta',
	);

	public $validate = array(
		'name' => array(
			'required' => array(
				'rule' => 'notEmpty',
				'message' => 'cannot be blank'
			)
		),
	);

	public $imageSlots = array(
		'main' => array(
			'slots' => 1,
			'fields' => array()
		),
	);

	public $hasAndBelongsToMany = array(
		'EvTeam.Department',
	);

	public function readForEdit($id, $query = array()) {
		$query['contain'][] = 'Department';

		return parent::readForEdit($id, $query);
	}

	public function getTeam($department_id) {
		if ($department_id) {
			$team =  $this->find('all', array(
				'conditions' => array(
					'TeamMember.is_active' => 1,
					'DepartmentTeamMember.department_id' => $department_id,
				),
				'joins' => array(
					array(
						'table' => 'departments_team_members',
						'alias' => 'DepartmentTeamMember',
						'type' => 'INNER',
						'conditions' => array(
							'DepartmentTeamMember.team_member_id = TeamMember.id'
						)
					)
				),
				'contain' => 'Image',
				'order' => 'TeamMember.name',
				'group' => 'TeamMember.id'
			));
		}
		else {
			//$team = $this->getFeatured();
			$team = $this->find('all', array(
				'conditions' => array(
					'TeamMember.is_active' => 1,
				),
				'contain' => 'Image',
				'order' => 'TeamMember.name ASC'
			));
		}
		return $team;
	}

	public function getFeatured() {
		return $this->find('all', array(
			'conditions' => array(
				'TeamMember.is_featured' => 1,
				'TeamMember.is_active' => 1,
			),
			'contain' => 'Image',
			'order' => 'RAND()'
		));
	}
}